Index: bookmarklets.html
===================================================================
--- bookmarklets.html	(revision 335)
+++ bookmarklets.html	(working copy)
@@ -1,6 +1,6 @@
 {% extends "base_site" %}
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; <a href="/doc/">Documentation</a> &rsaquo; Bookmarklets</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../">Home</a> &rsaquo; <a href="../">Documentation</a> &rsaquo; Bookmarklets</div>{% endblock %}
 
 {% block title %}Documentation bookmarklets{% endblock %}
 
Index: index.html
===================================================================
--- index.html	(revision 335)
+++ index.html	(working copy)
@@ -1,6 +1,6 @@
 {% extends "base_site" %}
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; Documentation</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../">Home</a> &rsaquo; Documentation</div>{% endblock %}
 
 {% block title %}Documentation{% endblock %}
 
Index: missing_docutils.html
===================================================================
--- missing_docutils.html	(revision 335)
+++ missing_docutils.html	(working copy)
@@ -1,6 +1,6 @@
 {% extends "base_site" %}
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; Documentation</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../">Home</a> &rsaquo; Documentation</div>{% endblock %}
 
 {% block title %}Please install docutils{% endblock %}
 
Index: model_detail.html
===================================================================
--- model_detail.html	(revision 335)
+++ model_detail.html	(working copy)
@@ -12,7 +12,7 @@
 
 {% endblock %}
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; <a href="/doc/">Documentation</a> &rsaquo; <a href="/doc/models/">Models</a> &rsaquo; {{ name }}</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../../">Home</a> &rsaquo; <a href="../../">Documentation</a> &rsaquo; <a href="../">Models</a> &rsaquo; {{ name }}</div>{% endblock %}
 
 {% block title %}Model: {{ name }}{% endblock %}
 
Index: model_index.html
===================================================================
--- model_index.html	(revision 335)
+++ model_index.html	(working copy)
@@ -2,7 +2,7 @@
 
 {% block coltype %}colSM{% endblock %}
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; <a href="/doc/">Documentation</a> &rsaquo; Models</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../">Home</a> &rsaquo; <a href="../">Documentation</a> &rsaquo; Models</div>{% endblock %}
 
 {% block title %}Models{% endblock %}
 
Index: template_filter_index.html
===================================================================
--- template_filter_index.html	(revision 335)
+++ template_filter_index.html	(working copy)
@@ -5,7 +5,7 @@
 
 
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; <a href="/doc/">Documentation</a> &rsaquo; filters</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../">Home</a> &rsaquo; <a href="../">Documentation</a> &rsaquo; filters</div>{% endblock %}
 
 
 {% block title %}Template filters{% endblock %}
Index: template_tag_index.html
===================================================================
--- template_tag_index.html	(revision 335)
+++ template_tag_index.html	(working copy)
@@ -5,7 +5,7 @@
 
 
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; <a href="/doc/">Documentation</a> &rsaquo; Tags</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../">Home</a> &rsaquo; <a href="../">Documentation</a> &rsaquo; Tags</div>{% endblock %}
 
 
 {% block title %}Template tags{% endblock %}
Index: view_detail.html
===================================================================
--- view_detail.html	(revision 335)
+++ view_detail.html	(working copy)
@@ -1,6 +1,6 @@
 {% extends "base_site" %}
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; <a href="/doc/">Documentation</a> &rsaquo; <a href="/doc/views/">Views</a> &rsaquo; {{ name }}</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../../">Home</a> &rsaquo; <a href="../../">Documentation</a> &rsaquo; <a href="../">Views</a> &rsaquo; {{ name }}</div>{% endblock %}
 
 {% block title %}View: {{ name }}{% endblock %}
 
Index: view_index.html
===================================================================
--- view_index.html	(revision 335)
+++ view_index.html	(working copy)
@@ -2,7 +2,7 @@
 
 {% block coltype %}colSM{% endblock %}
 
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="/">Home</a> &rsaquo; <a href="/doc/">Documentation</a> &rsaquo; Views</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../">Home</a> &rsaquo; <a href="../">Documentation</a> &rsaquo; Views</div>{% endblock %}
 
 {% block title %}Views{% endblock %}
 