Index: django/db/models/fields/__init__.py
===================================================================
--- django/db/models/fields/__init__.py	(revision 6352)
+++ django/db/models/fields/__init__.py	(working copy)
@@ -686,8 +686,7 @@
 
 class EmailField(CharField):
     def __init__(self, *args, **kwargs):
-        if 'max_length' not in kwargs:
-            kwargs['max_length'] = 75
+        kwargs['max_length'] = kwargs.get('max_length', 75)
         CharField.__init__(self, *args, **kwargs)
 
     def get_internal_type(self):
@@ -707,6 +706,7 @@
 class FileField(Field):
     def __init__(self, verbose_name=None, name=None, upload_to='', **kwargs):
         self.upload_to = upload_to
+        kwargs['max_length'] = kwargs.get('max_length', 100)        
         Field.__init__(self, verbose_name, name, **kwargs)
 
     def get_db_prep_save(self, value):
@@ -808,6 +808,7 @@
 class FilePathField(Field):
     def __init__(self, verbose_name=None, name=None, path='', match=None, recursive=False, **kwargs):
         self.path, self.match, self.recursive = path, match, recursive
+        kwargs['max_length'] = kwargs.get('max_length', 100)
         Field.__init__(self, verbose_name, name, **kwargs)
 
     def get_manipulator_field_objs(self):
Index: django/db/backends/ado_mssql/creation.py
===================================================================
--- django/db/backends/ado_mssql/creation.py	(revision 6352)
+++ django/db/backends/ado_mssql/creation.py	(working copy)
@@ -6,10 +6,10 @@
     'DateField':         'smalldatetime',
     'DateTimeField':     'smalldatetime',
     'DecimalField':      'numeric(%(max_digits)s, %(decimal_places)s)',
-    'FileField':         'varchar(100)',
-    'FilePathField':     'varchar(100)',
+    'FileField':         'varchar(%(max_length)s)',
+    'FilePathField':     'varchar(%(max_length)s)',
     'FloatField':        'double precision',
-    'ImageField':        'varchar(100)',
+    'ImageField':        'varchar(%(max_length)s)',
     'IntegerField':      'int',
     'IPAddressField':    'char(15)',
     'NullBooleanField':  'bit',
Index: django/db/backends/mysql_old/creation.py
===================================================================
--- django/db/backends/mysql_old/creation.py	(revision 6352)
+++ django/db/backends/mysql_old/creation.py	(working copy)
@@ -10,10 +10,10 @@
     'DateField':         'date',
     'DateTimeField':     'datetime',
     'DecimalField':      'numeric(%(max_digits)s, %(decimal_places)s)',
-    'FileField':         'varchar(100)',
-    'FilePathField':     'varchar(100)',
+    'FileField':         'varchar(%(max_length)s)',
+    'FilePathField':     'varchar(%(max_length)s)',
     'FloatField':        'double precision',
-    'ImageField':        'varchar(100)',
+    'ImageField':        'varchar(%(max_length)s)',
     'IntegerField':      'integer',
     'IPAddressField':    'char(15)',
     'NullBooleanField':  'bool',
Index: django/db/backends/postgresql/creation.py
===================================================================
--- django/db/backends/postgresql/creation.py	(revision 6352)
+++ django/db/backends/postgresql/creation.py	(working copy)
@@ -10,10 +10,10 @@
     'DateField':         'date',
     'DateTimeField':     'timestamp with time zone',
     'DecimalField':      'numeric(%(max_digits)s, %(decimal_places)s)',
-    'FileField':         'varchar(100)',
-    'FilePathField':     'varchar(100)',
+    'FileField':         'varchar(%(max_length)s)',
+    'FilePathField':     'varchar(%(max_length)s)',
     'FloatField':        'double precision',
-    'ImageField':        'varchar(100)',
+    'ImageField':        'varchar(%(max_length)s)',
     'IntegerField':      'integer',
     'IPAddressField':    'inet',
     'NullBooleanField':  'boolean',
Index: django/db/backends/sqlite3/creation.py
===================================================================
--- django/db/backends/sqlite3/creation.py	(revision 6352)
+++ django/db/backends/sqlite3/creation.py	(working copy)
@@ -9,10 +9,10 @@
     'DateField':                    'date',
     'DateTimeField':                'datetime',
     'DecimalField':                 'decimal',
-    'FileField':                    'varchar(100)',
-    'FilePathField':                'varchar(100)',
+    'FileField':                    'varchar(%(max_length)s)',
+    'FilePathField':                'varchar(%(max_length)s)',
     'FloatField':                   'real',
-    'ImageField':                   'varchar(100)',
+    'ImageField':                   'varchar(%(max_length)s)',
     'IntegerField':                 'integer',
     'IPAddressField':               'char(15)',
     'NullBooleanField':             'bool',
Index: django/db/backends/mysql/creation.py
===================================================================
--- django/db/backends/mysql/creation.py	(revision 6352)
+++ django/db/backends/mysql/creation.py	(working copy)
@@ -10,10 +10,10 @@
     'DateField':         'date',
     'DateTimeField':     'datetime',
     'DecimalField':      'numeric(%(max_digits)s, %(decimal_places)s)',
-    'FileField':         'varchar(100)',
-    'FilePathField':     'varchar(100)',
+    'FileField':         'varchar(%(max_length)s)',
+    'FilePathField':     'varchar(%(max_length)s)',
     'FloatField':        'double precision',
-    'ImageField':        'varchar(100)',
+    'ImageField':        'varchar(%(max_length)s)',
     'IntegerField':      'integer',
     'IPAddressField':    'char(15)',
     'NullBooleanField':  'bool',
Index: django/db/backends/oracle/creation.py
===================================================================
--- django/db/backends/oracle/creation.py	(revision 6352)
+++ django/db/backends/oracle/creation.py	(working copy)
@@ -13,10 +13,10 @@
     'DateField':                    'DATE',
     'DateTimeField':                'TIMESTAMP',
     'DecimalField':                 'NUMBER(%(max_digits)s, %(decimal_places)s)',
-    'FileField':                    'NVARCHAR2(100)',
-    'FilePathField':                'NVARCHAR2(100)',
+    'FileField':                    'NVARCHAR2(%(max_length)s)',
+    'FilePathField':                'NVARCHAR2(%(max_length)s)',
     'FloatField':                   'DOUBLE PRECISION',
-    'ImageField':                   'NVARCHAR2(100)',
+    'ImageField':                   'NVARCHAR2(%(max_length)s)',
     'IntegerField':                 'NUMBER(11)',
     'IPAddressField':               'VARCHAR2(15)',
     'NullBooleanField':             'NUMBER(1) CHECK ((%(column)s IN (0,1)) OR (%(column)s IS NULL))',
@@ -28,7 +28,7 @@
     'SmallIntegerField':            'NUMBER(11)',
     'TextField':                    'NCLOB',
     'TimeField':                    'TIMESTAMP',
-    'URLField':                     'VARCHAR2(200)',
+    'URLField':                     'VARCHAR2(%(max_length)s)',
     'USStateField':                 'CHAR(2)',
 }
 
Index: django/oldforms/__init__.py
===================================================================
--- django/oldforms/__init__.py	(revision 6352)
+++ django/oldforms/__init__.py	(working copy)
@@ -447,7 +447,7 @@
             self.field_name, self.rows, self.cols, escape(data))
 
 class HiddenField(FormField):
-    def __init__(self, field_name, is_required=False, validator_list=None):
+    def __init__(self, field_name, is_required=False, validator_list=None, max_length=None):
         if validator_list is None: validator_list = []
         self.field_name, self.is_required = field_name, is_required
         self.validator_list = validator_list[:]
@@ -674,7 +674,7 @@
 ####################
 
 class FileUploadField(FormField):
-    def __init__(self, field_name, is_required=False, validator_list=None):
+    def __init__(self, field_name, is_required=False, validator_list=None, max_length=None):
         if validator_list is None: validator_list = []
         self.field_name, self.is_required = field_name, is_required
         self.validator_list = [self.isNonEmptyFile] + validator_list
@@ -946,7 +946,7 @@
 
 class FilePathField(SelectField):
     "A SelectField whose choices are the files in a given directory."
-    def __init__(self, field_name, path, match=None, recursive=False, is_required=False, validator_list=None):
+    def __init__(self, field_name, path, match=None, recursive=False, is_required=False, validator_list=None, max_length=None):
         import os
         from django.db.models import BLANK_CHOICE_DASH
         if match is not None:
Index: tests/regressiontests/max_lengths/__init__.py
===================================================================
--- tests/regressiontests/max_lengths/__init__.py	(revision 0)
+++ tests/regressiontests/max_lengths/__init__.py	(revision 0)
@@ -0,0 +1 @@
+
Index: tests/regressiontests/max_lengths/tests.py
===================================================================
--- tests/regressiontests/max_lengths/tests.py	(revision 0)
+++ tests/regressiontests/max_lengths/tests.py	(revision 0)
@@ -0,0 +1,21 @@
+from django.test import TestCase
+from regressiontests.max_lengths.models import OldPerson, NewPerson
+
+class MaxLengths(TestCase):
+        
+    def verify_max_length(self, model,field,length):
+        self.assertEquals(model._meta.get_field(field).max_length,length)
+        
+    def test_oldp(self):
+        self.verify_max_length(OldPerson, 'email', 75)
+        self.verify_max_length(OldPerson, 'vcard', 100)
+        self.verify_max_length(OldPerson, 'your_mom', 100)
+        self.verify_max_length(OldPerson, 'homepage', 200)
+        self.verify_max_length(OldPerson, 'avatar', 100)
+
+    def test_newp(self):
+        self.verify_max_length(NewPerson, 'email', 384)
+        self.verify_max_length(NewPerson, 'vcard', 1024)
+        self.verify_max_length(NewPerson, 'your_mom', 512)
+        self.verify_max_length(NewPerson, 'homepage', 256)
+        self.verify_max_length(NewPerson, 'avatar', 512)
Index: tests/regressiontests/max_lengths/__init__.pyc
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: tests/regressiontests/max_lengths/__init__.pyc
___________________________________________________________________
Name: svn:mime-type
   + application/octet-stream

Index: tests/regressiontests/max_lengths/models.py
===================================================================
--- tests/regressiontests/max_lengths/models.py	(revision 0)
+++ tests/regressiontests/max_lengths/models.py	(revision 0)
@@ -0,0 +1,15 @@
+from django.db import models
+
+class OldPerson(models.Model):
+    email = models.EmailField()
+    vcard = models.FileField(upload_to='/tmp')
+    your_mom = models.ImageField(upload_to='/tmp')
+    homepage = models.URLField()
+    avatar = models.FilePathField()
+
+class NewPerson(models.Model):
+    email = models.EmailField(max_length=384)
+    vcard = models.FileField(upload_to='/tmp', max_length=1024)
+    your_mom = models.ImageField(upload_to='/tmp', max_length=512)
+    homepage = models.URLField(max_length=256)
+    avatar = models.FilePathField(max_length=512)
Index: tests/regressiontests/max_lengths/tests.pyc
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: tests/regressiontests/max_lengths/tests.pyc
___________________________________________________________________
Name: svn:mime-type
   + application/octet-stream

Index: tests/regressiontests/max_lengths/models.pyc
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: tests/regressiontests/max_lengths/models.pyc
___________________________________________________________________
Name: svn:mime-type
   + application/octet-stream

Index: docs/model-api.txt
===================================================================
--- docs/model-api.txt	(revision 6352)
+++ docs/model-api.txt	(working copy)
@@ -293,6 +293,10 @@
 
 .. _`strftime formatting`: http://docs.python.org/lib/module-time.html#l2h-1941
 
+In Django 0.96, this doesn't accept ``max_length``; its ``max_length`` is
+automatically set to 100. In the Django development version, ``max_length`` is
+set to 100 by default, but you can specify it to override default behavior.
+
 ``FilePathField``
 ~~~~~~~~~~~~~~~~~
 
@@ -330,6 +334,10 @@
 because the ``match`` applies to the base filename (``foo.gif`` and
 ``bar.gif``).
 
+In Django 0.96, this doesn't accept ``max_length``; its ``max_length`` is
+automatically set to 100. In the Django development version, ``max_length`` is
+set to 100 by default, but you can specify it to override default behavior.
+
 ``FloatField``
 ~~~~~~~~~~~~~~
 
@@ -361,6 +369,10 @@
 .. _Python Imaging Library: http://www.pythonware.com/products/pil/
 .. _elsewhere: ../db-api/#get-foo-height-and-get-foo-width
 
+In Django 0.96, this doesn't accept ``max_length``; its ``max_length`` is
+automatically set to 100. In the Django development version, ``max_length`` is
+set to 100 by default, but you can specify it to override default behavior.
+
 ``IntegerField``
 ~~~~~~~~~~~~~~~~
 