Index: django/db/models/fields/__init__.py
===================================================================
--- django/db/models/fields/__init__.py	(revision 4439)
+++ django/db/models/fields/__init__.py	(working copy)
@@ -582,6 +582,8 @@
 class FileField(Field):
     def __init__(self, verbose_name=None, name=None, upload_to='', **kwargs):
         self.upload_to = upload_to
+        if 'maxlength' not in kwargs:
+            kwargs['maxlength'] = 100
         Field.__init__(self, verbose_name, name, **kwargs)
 
     def get_manipulator_fields(self, opts, manipulator, change, name_prefix='', rel=False, follow=True):
@@ -663,6 +665,8 @@
 class FilePathField(Field):
     def __init__(self, verbose_name=None, name=None, path='', match=None, recursive=False, **kwargs):
         self.path, self.match, self.recursive = path, match, recursive
+        if 'maxlength' not in kwargs:
+            kwargs['maxlength'] = 100
         Field.__init__(self, verbose_name, name, **kwargs)
 
     def get_manipulator_field_objs(self):
Index: django/db/backends/ado_mssql/creation.py
===================================================================
--- django/db/backends/ado_mssql/creation.py	(revision 4439)
+++ django/db/backends/ado_mssql/creation.py	(working copy)
@@ -5,10 +5,10 @@
     'CommaSeparatedIntegerField': 'varchar(%(maxlength)s)',
     'DateField':         'smalldatetime',
     'DateTimeField':     'smalldatetime',
-    'FileField':         'varchar(100)',
-    'FilePathField':     'varchar(100)',
+    'FileField':         'varchar(%(maxlength)s)',
+    'FilePathField':     'varchar(%(maxlength)s)',
     'FloatField':        'numeric(%(max_digits)s, %(decimal_places)s)',
-    'ImageField':        'varchar(100)',
+    'ImageField':        'varchar(%(maxlength)s)',
     'IntegerField':      'int',
     'IPAddressField':    'char(15)',
     'ManyToManyField':   None,
Index: django/db/backends/postgresql/creation.py
===================================================================
--- django/db/backends/postgresql/creation.py	(revision 4439)
+++ django/db/backends/postgresql/creation.py	(working copy)
@@ -9,10 +9,10 @@
     'CommaSeparatedIntegerField': 'varchar(%(maxlength)s)',
     'DateField':         'date',
     'DateTimeField':     'timestamp with time zone',
-    'FileField':         'varchar(100)',
-    'FilePathField':     'varchar(100)',
+    'FileField':         'varchar(%(maxlength)s)',
+    'FilePathField':     'varchar(%(maxlength)s)',
     'FloatField':        'numeric(%(max_digits)s, %(decimal_places)s)',
-    'ImageField':        'varchar(100)',
+    'ImageField':        'varchar(%(maxlength)s)',
     'IntegerField':      'integer',
     'IPAddressField':    'inet',
     'ManyToManyField':   None,
Index: django/db/backends/sqlite3/creation.py
===================================================================
--- django/db/backends/sqlite3/creation.py	(revision 4439)
+++ django/db/backends/sqlite3/creation.py	(working copy)
@@ -8,10 +8,10 @@
     'CommaSeparatedIntegerField':   'varchar(%(maxlength)s)',
     'DateField':                    'date',
     'DateTimeField':                'datetime',
-    'FileField':                    'varchar(100)',
-    'FilePathField':                'varchar(100)',
+    'FileField':                    'varchar(%(maxlength)s)',
+    'FilePathField':                'varchar(%(maxlength)s)',
     'FloatField':                   'numeric(%(max_digits)s, %(decimal_places)s)',
-    'ImageField':                   'varchar(100)',
+    'ImageField':                   'varchar(%(maxlength)s)',
     'IntegerField':                 'integer',
     'IPAddressField':               'char(15)',
     'ManyToManyField':              None,
Index: django/db/backends/mysql/creation.py
===================================================================
--- django/db/backends/mysql/creation.py	(revision 4439)
+++ django/db/backends/mysql/creation.py	(working copy)
@@ -9,10 +9,10 @@
     'CommaSeparatedIntegerField': 'varchar(%(maxlength)s)',
     'DateField':         'date',
     'DateTimeField':     'datetime',
-    'FileField':         'varchar(100)',
-    'FilePathField':     'varchar(100)',
+    'FileField':         'varchar(%(maxlength)s)',
+    'FilePathField':     'varchar(%(maxlength)s)',
     'FloatField':        'numeric(%(max_digits)s, %(decimal_places)s)',
-    'ImageField':        'varchar(100)',
+    'ImageField':        'varchar(%(maxlength)s)',
     'IntegerField':      'integer',
     'IPAddressField':    'char(15)',
     'ManyToManyField':   None,
Index: django/db/backends/oracle/creation.py
===================================================================
--- django/db/backends/oracle/creation.py	(revision 4439)
+++ django/db/backends/oracle/creation.py	(working copy)
@@ -5,10 +5,10 @@
     'CommaSeparatedIntegerField': 'varchar2(%(maxlength)s)',
     'DateField':         'date',
     'DateTimeField':     'date',
-    'FileField':         'varchar2(100)',
-    'FilePathField':     'varchar2(100)',
+    'FileField':         'varchar2(%(maxlength)s)',
+    'FilePathField':     'varchar2(%(maxlength)s)',
     'FloatField':        'number(%(max_digits)s, %(decimal_places)s)',
-    'ImageField':        'varchar2(100)',
+    'ImageField':        'varchar2(%(maxlength)s)',
     'IntegerField':      'integer',
     'IPAddressField':    'char(15)',
     'ManyToManyField':   None,